<?php
/*
    StaticPageOutput.php
    Copyright 2007 MarkS
*/

if (!defined('PmWiki')) exit();

include_once($FarmD.'/scripts/xlpage-utf-8.php');

# Assume that pmwiki.php sets variable $ScriptUrl
$ApplicationPathUrl = dirname($ScriptUrl);
$ApplicationPathDir = realpath(dirname(__FILE__) . "/../.");

if (!isset($StaticPageDir)) {$StaticPageDir = "pub/web";} # Needs to be at least of length 1
if (!isset($StaticPageDirToWikiDir)) {$StaticPageDirToWikiDir = "./../..";}

if (!isset($StaticPageGeneratorActionName)){$StaticPageGeneratorActionName = 'StaticPageGenerator';}
if (!isset($StaticPageExclude)){$StaticPageExclude = array();}
if (!isset($StaticPageRegularExpressionExclude)){$StaticPageRegularExpressionExclude = array("/Site\..*/");}

if (!isset($StaticPageSaveActionPageList)){$StaticPageSaveActionPageList = array("Group.RecentChanges");}

if (!isset($StaticPageUpdateOnEditSaveAction)){$StaticPageUpdateOnEditSaveAction = TRUE;}

if (!isset($StaticPageAutomaticCreation)){$StaticPageAutomaticCreation = TRUE;}
if (!isset($StaticPageDeadLinks)){$StaticPageDeadLinks = array();}


if (!isset($ScriptUrlRemoteAddress)){

	$ScriptUrlRemoteAddress = "http";
    if ($_SERVER['HTTPS']=='on'){
    	$ScriptUrlRemoteAddress .= "s";
    }
    $ScriptUrlRemoteAddress .= "://" . $_SERVER['HTTP_HOST'] . ":" . $_SERVER['SERVER_PORT'] . $_SERVER['SCRIPT_NAME'];
}

if (!isset($StaticPageBrowseActionName)){$StaticPageBrowseActionName = 'browseStaticPage';}

if (!isset($HandleBrowseToPossibleStaticPage)){$HandleBrowseToPossibleStaticPage = 'HandleBrowseToPossibleStaticPage'; }


# Setup Variable for action.  Relative URLs will be used!
if ($action == $StaticPageBrowseActionName){

	global $ScriptUrl, $PubDirUrl, $ApplicationPathUrl;
	
	if ( ($foundPosn = strpos($ScriptUrl, $ApplicationPathUrl)) !== FALSE){
		$ScriptUrl = substr_replace($ScriptUrl, $StaticPageDirToWikiDir, $foundPosn, strlen($ApplicationPathUrl));
	}
	
	if ( ($foundPosn = strpos($PubDirUrl, $ApplicationPathUrl)) !== FALSE){
		$PubDirUrl = substr_replace($PubDirUrl, $StaticPageDirToWikiDir, $foundPosn, strlen($ApplicationPathUrl));
	}

}

if (!isset($ServerFileSystemEncoding)){
	if (strstr($_ENV["OS"], "Windows") !== FALSE){
		// It is assumed that for all other operating systems the default is UTF-8
		$ServerFileSystemEncoding = "WINDOWS-1252";
	}
}

global $FmtPV;
if (!isset($FmtPV['$staticPageName'])){$FmtPV['$staticPageName'] = '"$group.$name.html"';}

   
# When a wiki page is saved, update the static page.
if ($StaticPageUpdateOnEditSaveAction){
	global $EditFunctions;
	array_push($EditFunctions, "UpdateStaticPage");
}

# When pmwiki.php?action=$StaticPageGeneratorActionName
global $HandleActions;
if (!isset($HandleActions[$StaticPageGeneratorActionName])){
	$HandleActions[$StaticPageGeneratorActionName] = 'HandleStaticPageGenerator';
} 

global $HandleAuth;
if (!isset($HandleAuth[$StaticPageGeneratorActionName])){
	$HandleAuth[$StaticPageGeneratorActionName] = 'admin';
}


# When pmwiki.php?action=browseStaticPage
global $HandleActions;
if (!isset($HandleActions[$StaticPageBrowseActionName])){
	$HandleActions[$StaticPageBrowseActionName] = 'HandleBrowseStaticPage';
} 

global $HandleAuth;
if (!isset($HandleAuth[$StaticPageBrowseActionName])){
	$HandleAuth[$StaticPageBrowseActionName] = 'read';
}

global $HandleActions;
$HandleActions['browse'] = $HandleBrowseToPossibleStaticPage;


#################################################################################
#  Static Page Action Handlers
###############################################################################


# When pmwiki.php?action=$StaticPageGeneratorActionName
function HandleStaticPageGenerator($pagename, $auth = 'admin') {
	
	$page = RetrieveAuthPage($pagename, $auth, true);
  	if (!$page) { Abort("?unable to do action"); }
	
	include("StaticPageGenerator.php");
}

# When pmwiki.php?action=browseStaticPage
function HandleBrowseStaticPage($pagename, $auth = 'read') {
	HandleBrowseToPossibleStaticPage($pagename, $auth);
}

# When pmwiki.php?action=browse
function HandleBrowseToPossibleStaticPage($pagename, $auth = 'read'){
	
	global $StaticPageDir;
	# Let Wiki links point to static pages
	if (isset($StaticPageDir)){
		
		global $LinkFunctions, $StaticPageOutput_LinkFunctions;
		$StaticPageOutput_LinkFunctions = array();
		foreach($LinkFunctions as $key => $value) { 
			$StaticPageOutput_LinkFunctions[$key] = $value;
			$LinkFunctions[$key] = 'LinkStaticPages';
		}
	}
	
	HandleBrowse($pagename, $auth);
	
	global $action;
	if ($action == "browse"){
		global $StaticPageDeadLinks, $ApplicationPathDir;
		$StaticPageDeadLinks = array_values(array_unique($StaticPageDeadLinks));
		
		for ($index = 0; $index < sizeof($StaticPageDeadLinks); $index++) {
			createStaticPage($StaticPageDeadLinks[$index], $ApplicationPathDir);
		}
	}
	
}

function LinkStaticPages($pagename,$imap,$path,$title,$txt,$fmt=NULL){
	
	$linkFromStaticPage = FALSE;
	$linkToStaticPage = FALSE;
	
	global $StaticPageBrowseActionName, $action;
	if ($StaticPageBrowseActionName == $action){
		if (isPossibleStaticPage($pagename)){
			$linkFromStaticPage = TRUE;
		}
	}
	
	if ( isset($imap) && $imap == "<:page>" 
		&& (strstr($path, "?action=browse") === TRUE || strstr($path, "?action=") === FALSE)){
		
		// browse action for Page Link
		
		global $DefaultPage;
		$targetPageName = MakePageName($pagename, $path);
		
		//If $targetPageName exists, then links to a wiki page
		if ( strlen($targetPageName) > 0 ){
			if (isPossibleStaticPage($targetPageName)){

				$linkToStaticPage = TRUE;
				
				$static_pagename = getStaticPageName($targetPageName, "UTF-8");
				
				if ($linkFromStaticPage){
					$imap = "./";
					$path = $static_pagename;
				}else{
					global $StaticPageDir;
					$imap = "./";
					$path = $StaticPageDir . "/" . $static_pagename;
				}
			}
		}

	}
	
	global $StaticPageAutomaticCreation;
	if ($StaticPageAutomaticCreation === TRUE && $linkToStaticPage === TRUE){
		global $ApplicationPathDir, $StaticPageDir;
		
		# This is a static page link, 
		# so automatically create it otherwise it will be a dead link.
	    $wikiLinkStaticPageDir = $ApplicationPathDir . "/" .
	    	$StaticPageDir . "/" . getStaticPageName($targetPageName);
	    
	    if (!file_exists($wikiLinkStaticPageDir)){
	    	global $StaticPageDeadLinks;
	    	array_push($StaticPageDeadLinks, $targetPageName);
	    }
	}
	
	
	if (isset($imap)){
		$LinkFunctionType = $imap;
	}else{
		# Default in pmwiki.php:  $LinkFunctions['<:page>'] = 'LinkPage';
		$LinkFunctionType = "<:page>";  
	}
	global $StaticPageOutput_LinkFunctions;
	$link = $StaticPageOutput_LinkFunctions[$LinkFunctionType]($pagename,$imap,$path,$title,$txt,$fmt);
	
	return $link;
	
}


# When a wiki page is saved, does it update the corresponding static page
function UpdateStaticPage($pagename,&$page,&$new){
	global $IsPagePosted, $ApplicationPathDir;
	
	if ($IsPagePosted){
		createStaticPage($pagename, $ApplicationPathDir);
	}
	
	# $pagename should be in the form of "Main.HomePage"
	$pagenameGroup = substr($pagename, 0, strpos($pagename, "."));
    $pagenamePage = substr($pagename, strpos($pagename, ".") + 1, strlen($pagename) - 1);
	
	global $StaticPageSaveActionPageList;
    if (isset($StaticPageSaveActionPageList) && is_array($StaticPageSaveActionPageList)){
    	for ($index = 0; $index < sizeof($StaticPageSaveActionPageList); $index++) {
			$currentValue = $StaticPageSaveActionPageList[$index];
			
			$currentGroup = substr($currentValue, 0, strpos($currentValue, "."));
    		$currentPage = substr($currentValue, strpos($currentValue, ".") + 1, strlen($currentValue) - 1);
    		
    		# Group is a special keyword that is replaced with the group of the page being saved
    		if ($currentGroup == "Group"){
    			$currentValue = $pagenameGroup . "." . $currentPage;
    		}
    		
			createStaticPage($currentValue, $ApplicationPathDir);
		}    	
    }
    
}




####################   Static Page Query Methods  ################################


function isPossibleStaticPage($pagename){
		
	# $pagename in the form of "Main.HomePage"
	
	
	#Does it exist in the wiki directory
	if (!PageExists($pagename)){
		return FALSE;
	}
	
	# Standard Text match Exclude - Note to deprecate
    global $StaticPageExclude;
    if (isset($StaticPageExclude) && is_array($StaticPageExclude) 
    		&& in_array($pagename, $StaticPageExclude)){
    	// Remove Static Page if it exists
    	return FALSE;
    }
    
    # Regular Expression Exclude
    global $StaticPageRegularExpressionExclude;
    if (isset($StaticPageRegularExpressionExclude) && is_array($StaticPageRegularExpressionExclude)){
    	for ($index = 0; $index < sizeof($StaticPageRegularExpressionExclude); $index++) {
			$currentValue = $StaticPageRegularExpressionExclude[$index];
			if (preg_match($StaticPageRegularExpressionExclude[$index], $pagename) > 0){
				return FALSE;
			}
		}    	
    }
    
    # Not part of the exclude list
    return TRUE;
    
}

function getStaticPageName($pagename, $encoding=NULL){
    # $wikiLink is in the form of "Main.HomePage"
    
    #$pagename = PUE($pagename);
    
    if (strlen($pagename) < 3 || strpos($pagename, ".") === FALSE){
    	return "Main_HomePage.html";  # Default if not specified
    }

	$pagenameLink = FmtPageName('$staticPageName', $pagename);
		
	if ($encoding == NULL){
		global $ServerFileSystemEncoding;
		if (isset($ServerFileSystemEncoding)){
			$pagenameLink = mb_convert_encoding($pagenameLink, $ServerFileSystemEncoding, "UTF-8");
		}
	}else{
		if ($encoding != "UTF-8"){
			$pagenameLink = mb_convert_encoding($pagenameLink, $encoding, "UTF-8");
		}
	}
    
    return $pagenameLink;

}

function doesStaticPageExist($pagename){
	global $wikiDir, $StaticPageDir;
	
	$wikiLinkStaticPageDir = $wikiDir . "/" .
    	$StaticPageDir . "/" . getStaticPageName($pagename);
    	
    return file_exists($wikiLinkStaticPageDir);
}




####################   CREATE/REMOVE Static Page Methods  ################################


function createStaticPage($pagename, $wikiDir = "."){
	
   	# $pagename is in the form of "Main.HomePage"
   	$isStaticPageLink = isPossibleStaticPage($pagename);
   	
   	if (!$isStaticPageLink){
    	@removeStaticPage($pagename, $wikiDir);
    	return FALSE;
    }
   	
    global $ScriptUrlRemoteAddress, $StaticPageDir, $StaticPageBrowseActionName;
    	
    $wikiLinkAddress = $ScriptUrlRemoteAddress . "?n=" . $pagename . "&action=$StaticPageBrowseActionName";   
    
    $wikiLinkStaticPageDir = $wikiDir . "/" .
    	$StaticPageDir . "/" . getStaticPageName($pagename);
	
    if (! ($wikiLinkPageContents = file_get_contents($wikiLinkAddress)) ){
    	echo "Could not open URL for copying:  " .  $wikiLinkAddress;
    	return FALSE;
    }
    
	
	$wikiLinkPageContents = getStaticPageContents($wikiLinkPageContents);

	
	ensureStaticPageDirExists();
	    
    if (!($fpStaticPage = fopen($wikiLinkStaticPageDir , "w+"))){
       echo "Could not open file for writing:  " .  $wikiLinkStaticPageDir;
       return FALSE;
    }
    
    if (!(fwrite($fpStaticPage, $wikiLinkPageContents))){
       echo "Could not write to file:  " .  $wikiLinkStaticPageDir;
       return FALSE;
    }
    
    fclose($fpStaticPage);
    
    return TRUE;
    
}

function getStaticPageContents($htmlWikiPageContents){

	global $ScriptUrl;
	
	$htmlWikiPageContents = str_replace("'$ScriptUrl'", "'$ScriptUrl?n=Main.HomePage'", $htmlWikiPageContents);
	$htmlWikiPageContents = str_replace("\"$ScriptUrl\"", "\"$ScriptUrl?n=Main.HomePage\"", $htmlWikiPageContents);

	return $htmlWikiPageContents;

}

function removeStaticPage($pagename, $wikiDir = "."){
	
	global $StaticPageDir;
	
	if (isset($pagename) && strlen($pagename) > 1 && !(substr($pagename, 0, 1) == ".")){
		
		return unlink($wikiDir . "/" . 
			$StaticPageDir . "/" . getStaticPageName($pagename));  
	}
	
	return FALSE;
}




####################   FILE   I/O  ################################


function ensureStaticPageDirExists(){
	
	global $ApplicationPathDir, $StaticPageDir;
	
	$outputDir = $ApplicationPathDir . "/" . $StaticPageDir;
	
	if (!is_dir($outputDir)){
    	
    	# Permissions - Global Read and Write Access, No Execute
    	if (!MakeDirectoryPath($outputDir, 0006)){
    		echo "Could not create output directory for static files:  " .  $outputDir;
       		exit;
    	}
    }
}

function MakeDirectoryPath($path, $mode = 0755){
	
	# Attempt to create $dir directory
	if (is_dir($path) || @mkdir($path,$mode)){
		return TRUE;
	}
	# Attempt to create parent directory
	if (!MakeDirectoryPath(dirname($path),$mode)){
		return FALSE;
	}
	
	# Attempt again to create this directory
	return @mkdir($path,$mode);
}


?>
